import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.imageio.*;
import javax.swing.*;

//-------------------------------------
class Jigsaw extends JFrame implements Runnable, WindowListener {

static Jigsaw mf;

Canvas  cnvs;
JButton bgrd, pass, sbar;
JPanel  bbar;

//-------------------------------------
ArrayList<PlayingPiece> pieces;

boolean       doit, gamo, hint, newg, paus;
BufferedImage img;
Color         bclr;
double        etim, gtim, lsu;
Font          uif;
int           gamx, gamy, maxx, maxy, wxp, wyp;
int           uifs;
int           did, nump, selp, sper, ssiz;
int           id, lvl, mbx, mby, minssz, uid;
int           imgx, imgy, maxlvl, minlvl;
Int2D         pf;
//LogMsgs       lm;
long          ctim, otim;
Random        rndm;
String        stxt, uifn;
Thread        thrd;

//-------------------------------------
static final int UFSIZ   = 32;

static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";
static final String MAXLIT  = "MAXLVL";
static final String MINLIT  = "MINLVL";

static final int MINPRO = 50;
static final int NADD   = 5;
static final int UP     = 1;
static final int RIGHT  = 2;
static final int DOWN   = 3;
static final int LEFT   = 4;

static final int MAXMOV = 40;

//-------------------------------------
class ABackground implements ActionListener {
public void actionPerformed(ActionEvent ae) {
Color         nclr;
JColorChooser jcc;
  jcc = new JColorChooser(bclr);
  nclr = jcc.showDialog(mf, "new background", bclr);
  if (nclr!=null) {
    bclr = nclr;
    cnvs.setBackground(bclr);
  }
}}


//-------------------------------------
class AHint implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  hint = !hint;
}}

//-------------------------------------
class ALoad implements ActionListener {
public void actionPerformed(ActionEvent ae) {
File         f;
int          fsts;
JFileChooser fc;
  fc = new JFileChooser();
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    StopThread();
    f = fc.getSelectedFile();
    try {
      img = ImageIO.read(f);
    } catch (Exception x) { System.err.format("Exception: %s%n", x); }
    imgx = img.getWidth();
    imgy = img.getHeight();
    id = imgx;
    if (imgx>imgy) id = imgy;
    uid = id;
    lvl = 0;
    gamo = true;
    StartThread();
  }
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class ANewGame implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  newg = true;
}}

//-------------------------------------
class APass implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PassToNextPiece();
}}

//-------------------------------------
void AppQuit() {
  StopThread();
  System.exit(0);
}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  AppQuit();
}}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int kc;
  kc = ke.getKeyCode();
  if (kc==KeyEvent.VK_F1) PopupMain();
  if (kc==KeyEvent.VK_Q) AppQuit();
  if (kc==KeyEvent.VK_P) PassToNextPiece();
  if (kc==KeyEvent.VK_DOWN) MovePieceDown();
  if (kc==KeyEvent.VK_LEFT) MovePieceLeft();
  if (kc==KeyEvent.VK_RIGHT) MovePieceRight();
  if (kc==KeyEvent.VK_UP) MovePieceUp();
  if (kc==KeyEvent.VK_H) hint = !hint;
  if (kc==KeyEvent.VK_N) newg = true;
}}

//-------------------------------------
class CBMouse extends MouseAdapter {
//-----------------
public void mouseDragged(MouseEvent me) {
int x, y;
  x = me.getX();
  y = me.getY();
  MovePiece(x,y);
}
//-----------------
public void mousePressed(MouseEvent me) {
  mbx = me.getX();
  mby = me.getY();
}
//-----------------
public void mouseReleased(MouseEvent me) {
int x, y;
  x = me.getX();
  y = me.getY();
  EndMovePiece(x,y);
}
}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
  gamy = cnvs.getHeight();
  gamx = cnvs.getWidth();
}}

//-------------------------------------
void CheckGame() {
boolean      solved;
int          i, tot;
PlayingPiece pp;
String       fs, s;
  if (nump==0) return;
  solved = true;
  for (i=0; i<nump; i++) {
    pp = pieces.get(i);
    if (!pp.actual.equals(pp.target)) solved = false;
  }
  gamo = solved;
}

//-------------------------------------
void CreatePiece(Int2D pf) {
boolean      fnd;
int          num;
Point        np, p;
PlayingPiece piece;
Rectangle    r;
  nump++;
  p = DetermineStartPoint(pf);
  num = NumberFromPoint(p);
  r = DestRectFromNumber(num);
  piece = new PlayingPiece();
  piece.ia.add(num);
  piece.target.x = r.x;
  piece.target.y = r.y;
  if (gamy>gamx) {
    piece.actual.x = rndm.nextInt(sper/2)+(sper/4);
    piece.actual.x *= ssiz;
    piece.actual.y = did;
  } else {
    piece.actual.y = rndm.nextInt(sper/2)+(sper/4);
    piece.actual.y *= ssiz;
    piece.actual.x = did;
  }
  pf.Set(p.x, p.y, nump);
  fnd = true;
  while ((fnd)&&(piece.ia.size()<NADD)) {
    np = FindNextPoint(p, pf);
    if (np.x==-1) fnd = false;
    else {
      p = np;
      num = NumberFromPoint(p);
      piece.ia.add(num);
      pf.Set(p.x, p.y, nump);
    }
  }
  pieces.add(piece);
}

//---------------------------------------------
Rectangle DestRectFromNumber(int val) {
int        bx, by, sd, sx, sy;
Rectangle  r;
  val--;
  sx = val%sper;
  sy = val/sper;
  bx = (sx*ssiz);
  by = (sy*ssiz);
  r = new Rectangle(bx, by, bx+ssiz, by+ssiz);
  return(r);
}

//-------------------------------------
Point DetermineStartPoint(Int2D pf) {
boolean fnd;
int     i, j, val;
Point   rv;
  i = 0;
  j = 0;
  fnd = false;
  while (!fnd) {
    j = 0;
    while ((!fnd)&&(j<sper)) {
      val = pf.Get(i, j);
      if (val==0) fnd = true;
      else j++;
    }
    if (!fnd) i++;
  }
  rv = new Point(i, j);
  return(rv);
}

//-------------------------------------
void EndMovePiece(int x, int y) {
boolean      fnd;
int          dx, dy, nx, ny, osel;
PlayingPiece piece;
  if (selp==-1) return;
  MovePiece(x, y);
  piece = pieces.get(selp);
  nx = piece.actual.x+(ssiz/2);
  ny = piece.actual.y+(ssiz/2);
  nx /= ssiz;
  nx *= ssiz;
  ny /= ssiz;
  ny *= ssiz;
  if (nx<0) nx = 0;
  if (ny<0) ny = 0;
  piece.actual.x = nx;
  piece.actual.y = ny;
  mbx = x;
  mby = y;
  FindNextPiece();
}

//-------------------------------------
void FindNextPiece() {
boolean      fnd;
int          dx, dy, nx, ny, osel;
PlayingPiece pp;
  if (selp==-1) return;
  pp = pieces.get(selp);
  if (pp.actual.equals(pp.target)) {
    fnd = false;
    osel = selp;
    do {
      selp++;
      if (selp>=nump) selp = 0;
      pp = pieces.get(selp);
      if (!pp.actual.equals(pp.target)) fnd = true;
    } while (!fnd&&(selp!=osel));
    if (fnd) pp.show = true;
    else selp = -1;
  }
}

//-------------------------------------
Point FindNextPoint(Point p, Int2D pf) {
ArrayList<Integer> da;
boolean fnd;
int     idx, val;
Point   rv;
  rv = new Point(-1, -1);
  da = new ArrayList<Integer>();
  fnd = false;
  if (p.x>0) if (pf.Get(p.x-1, p.y)==0) da.add(LEFT);
  if (p.x<(sper-1)) if (pf.Get(p.x+1, p.y)==0) da.add(RIGHT);
  if (p.y>0) if (pf.Get(p.x, p.y-1)==0) da.add(UP);
  if (p.y<(sper-1)) if (pf.Get(p.x, p.y+1)==0) da.add(DOWN);
  if (da.size()>0) fnd = true;
  if (fnd) {
    idx = rndm.nextInt(da.size());
    val = da.get(idx);
    if (val==UP) rv = new Point(p.x, p.y-1);
    if (val==RIGHT) rv = new Point(p.x+1, p.y);
    if (val==DOWN) rv = new Point(p.x, p.y+1);
    if (val==LEFT) rv = new Point(p.x-1, p.y);
  }
  return(rv);
}

//-------------------------------------
public void Initlz() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  InitlzData();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
  iurl = this.getClass().getResource("/Jigsaw.png");
  tk = Toolkit.getDefaultToolkit();
  iimg = tk.createImage(iurl);
  mf.setIconImage(iimg);
  try {
    img = ImageIO.read(this.getClass().getResourceAsStream("/slide.jpg"));
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
  imgx = img.getWidth();
  imgy = img.getHeight();
  id = imgx;
  if (imgx>imgy) id = imgy;
  uid = id;
  StartThread();
}

//-------------------------------------
public void InitlzData() {
  uifs = UFSIZ;
  rndm = new Random();
  doit = false;
  gamo = true;
  hint = false;
  newg = false;
  paus = false;
  ssiz = 160;
  pf = new Int2D();
  pieces = new ArrayList<PlayingPiece>();
  selp = -1;
  lvl = 0;
//  lm = new LogMsgs("Jigsaw", mf);
  stxt = "Click Here";
  bclr = new Color(64, 0, 0);
  minlvl = 0;
  maxlvl = Math.min(maxx, maxy)/4;
}

//-------------------------------------
public void InitlzUI() {
  lvl = minlvl;
  gamx = (maxx*wxp)/100;
  gamy = (maxy*wyp)/100;
  did = gamx;
  if (did>gamy) did = gamy;
  minssz = did*MINPRO;
  minssz /= 1000;
  uif = new Font(uifn, Font.BOLD, uifs);
  Util.PutUIManFonts(uif);
  cnvs = new Canvas();
  cnvs.setBackground(bclr);
  cnvs.addMouseListener(new CBMouse());
  cnvs.addMouseMotionListener(new CBMouse());
  cnvs.addKeyListener(new CBKey());
  cnvs.addComponentListener(new CBResize());
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.setBackground(new Color(128, 16, 16));
  sbar.setForeground(new Color(255, 255, 0));
  bgrd = new JButton("bgrd");
  bgrd.setFont(uif);
  bgrd.addActionListener(new ABackground());
  bgrd.setBackground(new Color(64, 128, 255));
  bgrd.setForeground(new Color(0, 0, 0));
  pass = new JButton("pass");
  pass.setFont(uif);
  pass.addActionListener(new APass());
  pass.setBackground(new Color(64, 255, 128));
  pass.setForeground(new Color(0, 0, 0));
  bbar = new JPanel();
  bbar.add(bgrd);
  bbar.add(sbar);
  bbar.add(pass);
}

//-------------------------------------
public Jigsaw(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
  if (maxx>maxy) {
    wxp = 80;
    wyp = 90;
  } else {
    wxp = 90;
    wyp = 80;
  }
}

//-------------------------------------
void JumblePieces() {
int          i, r1, r2;
PlayingPiece p1, p2;
  i = nump*nump;
  while (i>0) {
    r1 = rndm.nextInt(nump);
    r2 = r1;
    while (r1==r2) r2 = rndm.nextInt(nump);
    p1 = pieces.get(r1);
    p2 = pieces.get(r2);
    pieces.set(r1, p2);
    pieces.set(r2, p1);
    i--;
  } 
}

//-------------------------------------
public void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.setSize(gamx, gamy+sbar.getHeight());
  mf.setLocation((maxx-gamx)/2, (maxy-(gamy+sbar.getHeight()))/2);
  mf.getContentPane().add(bbar, BorderLayout.NORTH);
  mf.getContentPane().add(cnvs, BorderLayout.CENTER);
  mf.setTitle("Jigsaw");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
public static void main(String[] args) {
  System.out.println("starting Jigsaw\n");
  mf = new Jigsaw(args);
  mf.Initlz();
}

//-------------------------------------
void MovePiece(int x, int y) {
int          dx, dy, nx, ny;
PlayingPiece piece;
  if (selp==-1) return;
  dx = x-mbx;
  dy = y-mby;
  if ((dx>MAXMOV)||(dy>MAXMOV)) return;
  piece = pieces.get(selp);
  nx = piece.actual.x;
  ny = piece.actual.y;
  nx += dx;
  ny += dy;
  if (nx<0) nx = 0;
  if (ny<0) ny = 0;
  piece.actual.x = nx;
  piece.actual.y = ny;
  mbx = x;
  mby = y;
}

//-------------------------------------
void MovePieceDown() {
PlayingPiece pp;
  if (selp==-1) return;
  pp = pieces.get(selp);
  pp.actual.y += ssiz;
  FindNextPiece();
}

//-------------------------------------
void MovePieceLeft() {
PlayingPiece pp;
  if (selp==-1) return;
  pp = pieces.get(selp);
  pp.actual.x -= ssiz;
  FindNextPiece();
}

//-------------------------------------
void MovePieceRight() {
PlayingPiece pp;
  if (selp==-1) return;
  pp = pieces.get(selp);
  pp.actual.x += ssiz;
  FindNextPiece();
}

//-------------------------------------
void MovePieceUp() {
PlayingPiece pp;
  if (selp==-1) return;
  pp = pieces.get(selp);
  pp.actual.y -= ssiz;
  FindNextPiece();
}

//-------------------------------------
void NewGame() {
int          i;
PlayingPiece pp;
  newg = false;
  lvl++;
  if (lvl>maxlvl) lvl = maxlvl;
  did = gamx;
  if (gamx>gamy) did = gamy;
  ssiz = did/4;
  for (i=0; i<lvl; i++) ssiz *= 3;
  for (i=0; i<lvl; i++) ssiz /= 4;
  if (ssiz<minssz) ssiz = minssz;
  sper = did/ssiz;
  pf.SizeTo(sper, sper);
  uid = id/sper;
  uid *= sper;
  did = sper*ssiz;
  nump = 0;
  pieces.clear();
  do {
    CreatePiece(pf);
  } while (NotFilled(pf));
  JumblePieces();
  selp = 0;
  pp = pieces.get(selp);
  pp.show = true;
  gamo = false;
  gtim = 0.0f;
  lsu  = 0.0f;
}

//---------------------------------------------
boolean NotFilled(Int2D pf) {
boolean rv;
int     i, j, val;
  rv = false;
  i = 0;
  while ((!rv)&&(i<sper)) {
    j = 0;
    while ((!rv)&&(j<sper)) {
      val = pf.Get(i, j);
      if (val==0) rv = true;
      else j++;
    }
    if (!rv) i++;
  }
  return(rv);
}

//---------------------------------------------
int NumberFromPoint(Point p) {
int   rv;
  rv = (p.y*sper)+(p.x)+1;
  return(rv);
}

//---------------------------------------------
void PassToNextPiece() {
boolean      fnd;
int          osel;
PlayingPiece pp;
  pp = pieces.get(selp);
  pp.show = false;
  if (gamy>gamx) {
    pp.actual.x = rndm.nextInt(sper/2)+(sper/4);
    pp.actual.x *= ssiz;
    pp.actual.y = did;
  } else {
    pp.actual.y = rndm.nextInt(sper/2)+(sper/4);
    pp.actual.y *= ssiz;
    pp.actual.x = did;
  }
  fnd = false;
  osel = selp;
  do {
    selp++;
    if (selp>=nump) selp = 0;
    pp = pieces.get(selp);
    if (!pp.actual.equals(pp.target)) fnd = true;
  } while (!fnd&&(selp!=osel));
  if (fnd) pp.show = true;
}
   
//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("New Game");
  mi.setMnemonic('N');
  mi.addActionListener(new ANewGame());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Pass");
  mi.setMnemonic('P');
  mi.addActionListener(new APass());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Background");
  mi.setMnemonic('B');
  mi.addActionListener(new ABackground());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Hint");
  mi.setMnemonic('H');
  mi.addActionListener(new AHint());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Load");
  mi.setMnemonic('L');
  mi.addActionListener(new ALoad());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(sbar, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"Jigsaw.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
        if (nam.compareTo(MAXLIT)==0) maxlvl = Integer.parseInt(val);
        if (nam.compareTo(MINLIT)==0) minlvl = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//---------------------------------------------
void RenderHint(Graphics g) {
AlphaComposite ac;
float          alpha;
Graphics2D     g2;
Rectangle      dr, sr;
  alpha = 0.5f;
  ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha);
  g2 = (Graphics2D)g;
  g2.setComposite(ac);
  dr = new Rectangle();
  sr = new Rectangle();
  sr.setBounds(0, 0, uid, uid);
  dr.setBounds(0, 0, did, did);
  g2.drawImage(img, dr.x, dr.y, dr.width+dr.x, dr.height+dr.y, sr.x, sr.y, sr.width+sr.x, sr.height+sr.y, null);
}

//---------------------------------------------
void RenderImage(Graphics g) {
Rectangle dr, sr;
  dr = new Rectangle();
  sr = new Rectangle();
  sr.setBounds(0, 0, uid, uid);
  dr.setBounds(0, 0, did, did);
  g.drawImage(img, dr.x, dr.y, dr.width+dr.x, dr.height+dr.y, sr.x, sr.y, sr.width+sr.x, sr.height+sr.y, null);
}

//---------------------------------------------
void RenderPieces(Graphics g) {
int          dx, dy, i, j, todo, val;
PlayingPiece pp;
Rectangle    cr, dr, sr;
  dr = new Rectangle();
  sr = new Rectangle();
  for (i=0; i<nump; i++) {
    pp = pieces.get(i);
    if ((pp.show)||(pp.actual.equals(pp.target))) {
      dx = pp.actual.x - pp.target.x;
      dy = pp.actual.y - pp.target.y;
      todo = pp.ia.size();
      for (j=0; j<todo; j++) {
        val = pp.ia.get(j);
        sr = SourceRectFromNumber(val);
        dr = DestRectFromNumber(val);
        cr = new Rectangle(dr.x+dx, dr.y+dy, ssiz, ssiz);
        g.drawImage(img, cr.x, cr.y, cr.width+cr.x, cr.height+cr.y, sr.x, sr.y, sr.width+sr.x, sr.height+sr.y, null);
      }
    }
  }
  if (selp!=-1) {
    pp = pieces.get(selp);
    dx = pp.actual.x - pp.target.x;
    dy = pp.actual.y - pp.target.y;
    todo = pp.ia.size();
    for (j=0; j<todo; j++) {
      val = pp.ia.get(j);
      sr = SourceRectFromNumber(val);
      dr = DestRectFromNumber(val);
      cr = new Rectangle(dr.x+dx, dr.y+dy, ssiz, ssiz);
      g.drawImage(img, cr.x, cr.y, cr.width+cr.x, cr.height+cr.y, sr.x, sr.y, sr.width+sr.x, sr.height+sr.y, null);
    }
  }
}

//---------------------------------------------
void RenderStatus() {
String  fs, s;
  if ((gtim-lsu)<0.4f) return;
  lsu = gtim;
  fs = "%d Pieces - %.02f";
  sbar.setText(String.format(fs, nump, gtim));
}

//-------------------------------------
void RenderTextCentered(Graphics g, String s, Rectangle r, Font f) {
FontMetrics fm;
int         x, y;
  fm = g.getFontMetrics(f);
  x = r.x+(r.width-fm.stringWidth(s))/2;
  y = r.y+((r.height-fm.getHeight())/2)+fm.getAscent();
  g.setFont(f);
  g.drawString(s, x, y);
}

//-------------------------------------
public void run() {
BufferStrategy bs;
Graphics       g;
  cnvs.createBufferStrategy(2);
  bs = cnvs.getBufferStrategy();
  doit = true;
  while (doit) {
    ctim = System.nanoTime();
    etim = (ctim - otim)/1000000000.0;
    otim = ctim;
    if (!paus) {
      g = bs.getDrawGraphics();
      g.clearRect(0, 0, gamx, gamy);
      if (newg) NewGame();
      if (gamo) RenderImage(g);
      else {
        gtim += etim;
        RenderPieces(g);
        if (hint) RenderHint(g);
        CheckGame();
      }
      RenderStatus();
      g.dispose();
      bs.show();
    }
    try {
       Thread.sleep(10);
    } catch (Exception ex) {}
  }
}

//---------------------------------------------
Rectangle SourceRectFromNumber(int val) {
int       bx, by, sd, sx, sy;
Rectangle r;
  sd = uid/sper;
  val--;
  sx = val%sper;
  sy = val/sper;
  bx = (sx*sd);
  by = (sy*sd);
  r = new Rectangle(bx, by, sd, sd);
  return(r);
}

//-------------------------------------
private void StartThread() {
  if ((thrd==null) || !doit) {
    otim = System.nanoTime();
    thrd = new Thread(this);
    thrd.start();
  }
}

//-------------------------------------
private void StopThread() {
  if (thrd!=null) {
    doit = false;
    try {
      thrd.join();
    } catch (InterruptedException ex) {}
    thrd = null;
  }
}

//-------------------------------------
public void windowActivated(WindowEvent e) { paus = false; }
public void windowDeactivated(WindowEvent e) { paus = true; }
public void windowDeiconified(WindowEvent e) { paus = false; }
public void windowIconified(WindowEvent e) { paus = true; }
public void windowClosing(WindowEvent e) { doit = false; }
public void windowClosed(WindowEvent e) { doit = false; }
public void windowOpened(WindowEvent e) { paus = false; }

//-------------------------------------
}
